clc;
clear;
close all;

CostFunction = @(x) optimize_Kesirli_PID(x);      

nVar = 5;            

VarSize = [1 nVar];   

VarMin = [1 0.001 1 0.001 0.001];
VarMax  =[10 1 30 0.999 0.999];

		
%%

MaxIt = 100;            

nPop = 30;            

nOnlooker = nPop;        

L = round(0.6*nVar*nPop); 

a = 1;                    

%% 

empty_bee.Position = [];
empty_bee.Cost = [];

pop = repmat(empty_bee, nPop, 1);

BestSol.Cost = inf;

for i = 1:nPop
    pop(i).Position = unifrnd(VarMin, VarMax, VarSize);
    pop(i).Cost = feval(CostFunction,pop(i).Position);
    if pop(i).Cost <= BestSol.Cost
        BestSol = pop(i);
    end
end


C = zeros(nPop, 1);

BestCost = zeros(MaxIt, 1);

%%

for it = 1:MaxIt
    
    for i = 1:nPop
        
        K = [1:i-1 i+1:nPop];
        k = K(randi([1 numel(K)]));
        
        phi = a*unifrnd(-1, +1, VarSize);
        
        newbee.Position = pop(i).Position+phi.*(pop(i).Position-pop(k).Position);
        
        newbee.Position = max(newbee.Position, VarMin);
        newbee.Position = min(newbee.Position, VarMax);

        newbee.Cost = feval(CostFunction,newbee.Position);
        
        if newbee.Cost <= pop(i).Cost
            pop(i) = newbee;
        else
            C(i) = C(i)+1;
        end
        
    end
    
    F = zeros(nPop, 1);
    MeanCost = mean([pop.Cost]);
    for i = 1:nPop
        F(i) = exp(-pop(i).Cost/MeanCost); 
    end
    P = F/sum(F);
    
    for m = 1:nOnlooker
        
        i = RouletteWheelSelection(P);
        
        K = [1:i-1 i+1:nPop];
        k = K(randi([1 numel(K)]));
        
        phi = a*unifrnd(-1, +1, VarSize);
        
        newbee.Position = pop(i).Position+phi.*(pop(i).Position-pop(k).Position);
        
        newbee.Position = max(newbee.Position, VarMin);
        newbee.Position = min(newbee.Position, VarMax);
        
        newbee.Cost = feval(CostFunction,newbee.Position);
        
        if newbee.Cost <= pop(i).Cost
            pop(i) = newbee;
        else
            C(i) = C(i) + 1;
        end
        
    end
    
    for i = 1:nPop
        if C(i) >= L
            pop(i).Position = unifrnd(VarMin, VarMax, VarSize);
            pop(i).Cost = feval(CostFunction,pop(i).Position);
            C(i) = 0;
        end
    end
    
    for i = 1:nPop
        if pop(i).Cost <= BestSol.Cost
            BestSol = pop(i);
        end
    end
    
    BestCost(it) = BestSol.Cost;
    
    disp(['Iteration ' num2str(it) ': Best Cost = ' num2str(BestCost(it)) ': Best Post = ' num2str(BestSol.Position)]);
    
end

